﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="ModuleAdministration.ascx.cs" Inherits="SilverlightDesktop.Module.ModuleAdministration" %>
<div align="left">
    <asp:LinkButton ID="lnkBack" runat="server" Font-Underline="True" 
        onclick="lnkBack_Click">[Back to Main]</asp:LinkButton>
    <asp:LinqDataSource ID="LDSModuleSettings" runat="server" 
        ContextTypeName="SilverlightDesktop.SilverlightDesktopDAL" EnableDelete="True" 
        EnableInsert="True" EnableUpdate="True" OrderBy="ModuleName" 
        TableName="SilverlightDesktopModules">
    </asp:LinqDataSource>
    <br />
    <asp:ListView ID="ListView1" runat="server" DataKeyNames="ModuleID" 
        DataSourceID="LDSModuleSettings" InsertItemPosition="LastItem" 
        OnItemDeleting="ListView1_ItemDeleting" OnItemInserted="ListView1_ItemInserted">
        <LayoutTemplate>
            <table runat="server">
                <tr runat="server">
                    <td runat="server">
                        <table ID="itemPlaceholderContainer" runat="server" border="1" style="background-color: #FFFFFF;
                                        border-collapse: collapse; border-color: #999999; border-style: none; border-width: 1px;
                                        font-family: Verdana, Arial, Helvetica, sans-serif;">
                            <tr runat="server" style="background-color: #E0FFFF; color: #333333;">
                                <th runat="server">
                                </th>
                                <th runat="server">
                                    Name
                                </th>
                                <th runat="server">
                                    Description
                                </th>
                                <th runat="server">
                                    Assembly
                                </th>
                                <th runat="server">
                                    Class
                                </th>
                                <th runat="server">
                                    Icon
                                </th>
                                <th runat="server">
                                    Role
                                </th>
                                <th runat="server">
                                    WindowSize
                                </th>
                                <th runat="server">
                                    Multiple?
                                </th>
                                <th runat="server">
                                    Version
                                </th>
                            </tr>
                            <tr ID="itemPlaceholder" runat="server">
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr runat="server">
                    <td runat="server" style="text-align: center; background-color: #5D7B9D; font-family: Verdana, Arial, Helvetica, sans-serif;
                                    color: #FFFFFF">
                        <asp:DataPager ID="DataPager1" runat="server">
                            <Fields>
                                <asp:NextPreviousPagerField ButtonType="Button" ShowFirstPageButton="True" 
                                    ShowLastPageButton="True" />
                            </Fields>
                        </asp:DataPager>
                    </td>
                </tr>
            </table>
        </LayoutTemplate>
        <InsertItemTemplate>
            <tr style="">
                <td>
                    <asp:Button ID="InsertButton" runat="server" CommandName="Insert" 
                        Text="Insert" />
                    <asp:Button ID="CancelButton" runat="server" CommandName="Cancel" 
                        Text="Clear" />
                </td>
                <td>
                    <asp:TextBox ID="ModuleNameTextBox" runat="server" 
                        Text='<%# Bind("ModuleName") %>' />
                </td>
                <td>
                    <asp:TextBox ID="ModuleDescriptionTextBox" runat="server" Columns="20" Rows="1" 
                        Text='<%# Bind("ModuleDescription") %>' TextMode="MultiLine" />
                </td>
                <td>
                    <asp:TextBox ID="AssemblyNameTextBox" runat="server" 
                        Text='<%# Bind("AssemblyName") %>' />
                </td>
                <td>
                    <asp:TextBox ID="ClassNameTextBox" runat="server" 
                        Text='<%# Bind("ClassName") %>' />
                </td>
                <td>
                    <asp:TextBox ID="IconNameTextBox" runat="server" Columns="8" 
                        Text='<%# Bind("IconName") %>' />
                </td>
                <td>
                    <asp:DropDownList ID="ddlRoles" runat="server" 
                        SelectedValue='<%# Bind("Role") %>'>
                        <asp:ListItem>Any</asp:ListItem>
                        <asp:ListItem>Registered Users</asp:ListItem>
                    </asp:DropDownList>
                </td>
                <td>
                    <asp:TextBox ID="WindowSizeTextBox" runat="server" Columns="2" 
                        Text='<%# Bind("WindowSize") %>' />
                </td>
                <td>
                    <asp:CheckBox ID="AllowMultipleInstancesCheckBox" runat="server" 
                        Checked='<%# Bind("AllowMultipleInstances") %>' />
                </td>
                <td>
                    <asp:TextBox ID="ModuleVersionTextBox" runat="server" Columns="2" 
                        Text='<%# Bind("ModuleVersion") %>' />
                    <asp:HiddenField ID="HiddenField1" runat="server" 
                        Value='<%# Bind("uninstall") %>' />
                </td>
            </tr>
        </InsertItemTemplate>
        <SelectedItemTemplate>
            <tr style="font-weight: bold; color: #333333;">
                <td>
                    <asp:Button ID="DeleteButton" runat="server" CommandName="Delete" 
                        Text="Delete" />
                    <asp:Button ID="EditButton" runat="server" CommandName="Edit" Text="Edit" />
                </td>
                <td>
                    <asp:Label ID="ModuleNameLabel" runat="server" 
                        Text='<%# Eval("ModuleName") %>' />
                </td>
                <td>
                    <asp:Label ID="ModuleDescriptionLabel" runat="server" 
                        Text='<%# Eval("ModuleDescription") %>' />
                </td>
                <td>
                    <asp:Label ID="AssemblyNameLabel" runat="server" 
                        Text='<%# Eval("AssemblyName") %>' />
                </td>
                <td>
                    <asp:Label ID="ClassNameLabel" runat="server" Text='<%# Eval("ClassName") %>' />
                </td>
                <td>
                    <asp:Label ID="IconNameLabel" runat="server" Text='<%# Eval("IconName") %>' />
                </td>
                <td>
                    <asp:Label ID="RoleLabel" runat="server" Text='<%# Eval("Role") %>' />
                </td>
                <td>
                    <asp:Label ID="WindowSizeLabel" runat="server" Columns="2" 
                        Text='<%# Eval("WindowSize") %>' />
                </td>
                <td>
                    <asp:CheckBox ID="AllowMultipleInstancesCheckBox0" runat="server" 
                        Checked='<%# Eval("AllowMultipleInstances") %>' Enabled="false" />
                </td>
                <td>
                    <asp:Label ID="ModuleVersionLabel" runat="server" Columns="2" 
                        Text='<%# Eval("ModuleVersion") %>' />
                </td>
            </tr>
        </SelectedItemTemplate>
        <EmptyDataTemplate>
            <table runat="server" style="background-color: #FFFFFF; border-collapse: collapse;
                            border-color: #999999; border-style: none; border-width: 1px;">
                <tr>
                    <td>
                        There are no modules installed.
                    </td>
                </tr>
            </table>
        </EmptyDataTemplate>
        <EditItemTemplate>
            <tr>
                <td>
                    <asp:Button ID="UpdateButton" runat="server" CommandName="Update" 
                        Text="Update" />
                    <asp:Button ID="CancelButton0" runat="server" CommandName="Cancel" 
                        Text="Cancel" />
                </td>
                <td>
                    <asp:TextBox ID="ModuleNameTextBox0" runat="server" 
                        Text='<%# Bind("ModuleName") %>' />
                </td>
                <td>
                    <asp:TextBox ID="ModuleDescriptionTextBox0" runat="server" Columns="20" 
                        Rows="1" Text='<%# Bind("ModuleDescription") %>' TextMode="MultiLine" />
                </td>
                <td>
                    <asp:TextBox ID="AssemblyNameTextBox0" runat="server" 
                        Text='<%# Bind("AssemblyName") %>' />
                </td>
                <td>
                    <asp:TextBox ID="ClassNameTextBox0" runat="server" 
                        Text='<%# Bind("ClassName") %>' />
                </td>
                <td>
                    <asp:TextBox ID="IconNameTextBox0" runat="server" Columns="8" 
                        Text='<%# Bind("IconName") %>' />
                </td>
                <td>
                    <asp:DropDownList ID="ddlRoles0" runat="server" 
                        SelectedValue='<%# Bind("Role") %>'>
                        <asp:ListItem>Any</asp:ListItem>
                        <asp:ListItem>Registered Users</asp:ListItem>
                    </asp:DropDownList>
                </td>
                <td>
                    <asp:TextBox ID="WindowSizeTextBox0" runat="server" Columns="2" 
                        Text='<%# Bind("WindowSize") %>' />
                </td>
                <td>
                    <asp:CheckBox ID="AllowMultipleInstancesCheckBox1" runat="server" 
                        Checked='<%# Bind("AllowMultipleInstances") %>' />
                </td>
                <td>
                    <asp:TextBox ID="ModuleVersionTextBox0" runat="server" Columns="2" 
                        Text='<%# Bind("ModuleVersion") %>' />
                    <asp:HiddenField ID="HiddenField2" runat="server" 
                        Value='<%# Bind("uninstall") %>' />
                </td>
            </tr>
        </EditItemTemplate>
        <ItemTemplate>
            <tr style="color: #333333;">
                <td>
                    <asp:Button ID="DeleteButton0" runat="server" CommandName="Delete" 
                        OnClientClick="return confirm('Are you certain you want to delete ?'); " 
                        Text="Delete" />
                    <asp:Button ID="EditButton0" runat="server" CommandName="Edit" Text="Edit" />
                </td>
                <td>
                    <asp:Label ID="ModuleNameLabel0" runat="server" 
                        Text='<%# Eval("ModuleName") %>' />
                </td>
                <td>
                    <asp:Label ID="ModuleDescriptionLabel0" runat="server" 
                        Text='<%# Eval("ModuleDescription") %>' />
                </td>
                <td>
                    <asp:Label ID="AssemblyNameLabel0" runat="server" 
                        Text='<%# Eval("AssemblyName") %>' />
                </td>
                <td>
                    <asp:Label ID="ClassNameLabel0" runat="server" 
                        Text='<%# Eval("ClassName") %>' />
                </td>
                <td>
                    <asp:Label ID="IconNameLabel0" runat="server" Text='<%# Eval("IconName") %>' />
                </td>
                <td>
                    <asp:Label ID="RoleLabel0" runat="server" Text='<%# Eval("Role") %>' />
                </td>
                <td>
                    <asp:Label ID="WindowSizeLabel0" runat="server" 
                        Text='<%# Eval("WindowSize") %>' />
                </td>
                <td>
                    <asp:CheckBox ID="AllowMultipleInstancesCheckBox2" runat="server" 
                        Checked='<%# Eval("AllowMultipleInstances") %>' Enabled="false" />
                </td>
                <td>
                    <asp:Label ID="ModuleVersionLabel0" runat="server" 
                        Text='<%# Eval("ModuleVersion") %>' />
                </td>
            </tr>
        </ItemTemplate>
    </asp:ListView>
    <p>
        Upload New Module</p>
    <p>
        <input id="File1" runat="server" type="file" />
        <asp:Button ID="btnUpload" runat="server" OnClick="btnUpload_Click" 
            Text="Upload" />
    </p>
    <asp:Label ID="lblModuleError" runat="server" EnableViewState="False" 
        ForeColor="Red"></asp:Label>
&nbsp;<br />
    <br />
    <asp:ListBox ID="ErrorListBox" runat="server" EnableViewState="False" Rows="10" 
        SelectionMode="Multiple" Visible="False" Width="100%"></asp:ListBox></div>

